//Codec for this file is Windows-1251
//C++17

//:  2020

#ifndef FUNCWRAPPER_H
#define FUNCWRAPPER_H

#include <string>
#include <string_view>

//#define DEBUG

#ifdef DEBUG
#include <iostream>
#endif // DEBUG

class FuncWrapper { //  
protected:
    std::string res_str{""}, err_str{""};
    // Api    GetLastError()
    static std::string err_description(std::string_view fun_name);
public:
    FuncWrapper() = default;

    #ifdef DEBUG
    virtual ~FuncWrapper() {std::cout << "dtor\n";}
    #endif // DEBUG

    #ifndef DEBUG
    virtual ~FuncWrapper() = default;
    #endif // DEBUG

    virtual bool exec() = 0; //   
    //  (),    ..(?)
    std::string result_string() {
        return res_str;
    }
    std::string error_string() {
        return err_str;
    }
};

/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        .     
   ,        !

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/


#define INHERITANCE_MACRO(CLASS_NAME)\
class CLASS_NAME : public FuncWrapper {\
public:\
    bool exec() override;\
};

INHERITANCE_MACRO(PlatformInfo)
INHERITANCE_MACRO(Language)
INHERITANCE_MACRO(UserName)
INHERITANCE_MACRO(CompName)
INHERITANCE_MACRO(WinDir)
INHERITANCE_MACRO(SysDir)
INHERITANCE_MACRO(CurrDir)
INHERITANCE_MACRO(GlobMemStEx)
INHERITANCE_MACRO(PerfInf)
INHERITANCE_MACRO(Intel_x86_ProcArch)
INHERITANCE_MACRO(VideoCard)
INHERITANCE_MACRO(DefaultPrinter)
INHERITANCE_MACRO(PrintersInfo)
INHERITANCE_MACRO(DiscsTypes)
INHERITANCE_MACRO(Procs_by_TlHelp32)
INHERITANCE_MACRO(Procs_by_Psapi)
INHERITANCE_MACRO(DevicesList)


#endif //FUNCWRAPPER_H
