//Codec for this file is Windows-1251
//.   C++17

/*

                        CppSysInfo v.1.50 beta5

              -    Windows API.

 ..,  2020
sadovoya@mtu-net.ru
sadovoya.narod.ru

 , " "

*/

#include "FuncWrapper.h"
#include "Helper.h"
#include <string>
#include <vector>
#include <memory>


int main() {

    volatile ::DWORD time = ::GetTickCount();

    {
        //https://en.cppreference.com/w/cpp/memory/unique_ptr
        std::vector<std::unique_ptr<FuncWrapper>> fv;
        fv.push_back(std::make_unique<PlatformInfo>());
        fv.push_back(std::make_unique<Language>());
        fv.push_back(std::make_unique<UserName>());
        fv.push_back(std::make_unique<CompName>());
        fv.push_back(std::make_unique<WinDir>());
        fv.push_back(std::make_unique<SysDir>());
        fv.push_back(std::make_unique<CurrDir>());
        fv.push_back(std::make_unique<GlobMemStEx>());
        fv.push_back(std::make_unique<PerfInf>());
        fv.push_back(std::make_unique<Intel_x86_ProcArch>());
        fv.push_back(std::make_unique<VideoCard>());
        fv.push_back(std::make_unique<DefaultPrinter>());
        fv.push_back(std::make_unique<PrintersInfo>());
        fv.push_back(std::make_unique<DiscsTypes>());
        fv.push_back(std::make_unique<Procs_by_TlHelp32>());
        fv.push_back(std::make_unique<Procs_by_Psapi>());
        fv.push_back(std::make_unique<DevicesList>());

        std::string str{" :\n\n"};
        for(auto& p : fv)
            p->exec() ? str += p->result_string() + "\n\n"
                : str += p->error_string() + "\n\n";

        FileOutput res_file(".txt");
        if( !res_file.isValid() ) {
            ::ApiWriteAsOem("  .\n");
            return -1000;
        }

        if( !res_file.write(str.c_str(), str.length()-1) ) {
            ::ApiWriteAsOem("   .\n");
            return -2000;
        }

        if( !res_file.close() ) //  
            ::ApiWriteAsOem(".    .\n");
    }

    time = ::GetTickCount() - time;

    HeapBuffer<char> dest{512};
    if( dest.isValid() ) {
        ::wsprintfA(dest.get(), "  %lu .\n", time);
        ::ApiWriteAsOem(dest.get());
    } else
        ::ApiWriteAsOem(".    .\n");

    ::ApiWriteAsOem(".    \".txt\"\
        \n   .\n");

    ::Sleep(3000);

    return 0;
}
